/*
  CXbase1.c
 
*/
#include "simpletools.h"
#include "simpletext.h"
#include "fdserial.h"

serial *create;
serial *xbee;
serial *rpi;

int speed_right = 100;
int speed_left = 100;
int turn_left = 50;
int turn_right = 50;

void CsafeM(void);
void CstartM(void);
void stop_Bot();
void drive_Fore();
void drive_Back();
void drive_Left();
void drive_Rite();
void drive_Dock();

int XB_remote(void);
int rpi_direct();

void ILcmd();
void DILcmd();

blink();

int main()
{
  // Add startup code here.
/*                       Rx Tx mode   BAUD*/
  create = fdserial_open(8, 9,  0,   57600);
  pause(1000);
  xbee = fdserial_open(11,12,0,9600);
  pause(250);
  rpi = fdserial_open(31,30,0,115200);

  int cog;

  cog = cog_run(&blink,10);

  int xbcmd = -1;
  int rpicmd = -1;

// Add main loop code here.
  while(1)
  {
    xbcmd = XB_remote();
    rpicmd = rpi_direct();
  }
  
}

blink()
{
  while(1)
  {
    high(26);
    pause(500);
    low(26);
    pause(500);
  }
}

int rpi_direct()
{
  char inBuff[40];
  char inDuff[5];
  int retval = 0;

  if(fdserial_rxReady(rpi))
  {
    readStr(rpi, inBuff, 40);
    if(!strcmp(inBuff,"onled")) high(26);
    else if(!strcmp(inBuff,"offled")) low(26);
    else if(!strcmp(inBuff,"safemode")) CsafeM();
    else if(!strcmp(inBuff,"gostop")) stop_Bot();
    else if(!strcmp(inBuff,"gofore")) drive_Fore();
    else if(!strcmp(inBuff,"goback")) drive_Back();
    else if(!strcmp(inBuff,"goleft")) drive_Left();
    else if(!strcmp(inBuff,"gorite")) drive_Rite();
    else if(!strcmp(inBuff,"runprog")) DILcmd();
    else if(!strcmp(inBuff,"onPin"))
    {
      readStr(rpi,inDuff,10);
      pause(100);
      int d = atoi(inDuff);
      high(d);
    }
    else if(!strcmp(inBuff,"offPin"))
    {
      readStr(rpi, inDuff,10);
      pause(100);
      int d = atoi(inDuff);
      low(d);
    }
    else if(!strcmp(inBuff,"fdistance"))
    {
      readStr(rpi, inDuff,10);
      pause(100);
      int d = atoi(inDuff);
      d = (d * 25.4);  // Convert to inches
      drive_Fore();
      fdserial_txChar(create,156);
      fdserial_txChar(create,((d)>>8)&0xFF);
      fdserial_txChar(create,((d)&0xFF));
      stop_Bot();
    }
    else if(!strcmp(inBuff,"bdistance"))
    {
      readStr(rpi, inDuff,10);
      pause(100);
      int d = atoi(inDuff);
      d = (d * 25.4);  // Convert to inches
      drive_Back();
      fdserial_txChar(create,156);
      fdserial_txChar(create,((-d)>>8)&0xFF);
      fdserial_txChar(create,((-d)&0xFF));
      stop_Bot();
    }
    else if(!strcmp(inBuff,"ldistance"))
    {
      readStr(rpi, inDuff,10);
      pause(100);
      int d = atoi(inDuff);
      drive_Left();
      fdserial_txChar(create,157);
      fdserial_txChar(create,((d)>>8)&0xFF);
      fdserial_txChar(create,((d)&0xFF));
      stop_Bot();      
    }
    else if(!strcmp(inBuff,"rdistance"))
    {
      readStr(rpi, inDuff,10);
      pause(100);
      int d = atoi(inDuff);
      drive_Rite();
      fdserial_txChar(create,157);
      fdserial_txChar(create,((-d)>>8)&0xFF);
      fdserial_txChar(create,((-d)&0xFF));
      stop_Bot();
    }
    else if(!strcmp(inBuff,"dock")) drive_Dock();
    else if(!strcmp(inBuff,"startmode")) CstartM();
    else
    {
      writeStr(rpi,"??");
      retval = -1;
    }    
  }
  return retval;  
}

int XB_remote(void)
{
  char inBuff[40];
  char inDuff[5];
  int retval = 0;

  if(fdserial_rxReady(xbee))
  {
    readStr(xbee, inBuff, 40);
    if(!strcmp(inBuff,"onled")) high(26);
    else if(!strcmp(inBuff,"offled")) low(26);
    else if(!strcmp(inBuff,"safemode")) CsafeM();
    else if(!strcmp(inBuff,"gostop")) stop_Bot();
    else if(!strcmp(inBuff,"gofore")) drive_Fore();
    else if(!strcmp(inBuff,"goback")) drive_Back();
    else if(!strcmp(inBuff,"goleft")) drive_Left();
    else if(!strcmp(inBuff,"gorite")) drive_Rite();
    else if(!strcmp(inBuff,"runprog")) ILcmd();
    else if(!strcmp(inBuff,"onPin"))
    {
      readStr(xbee,inDuff,10);
      pause(100);
      int d = atoi(inDuff);
      high(d);
    }
    else if(!strcmp(inBuff,"offPin"))
    {
      readStr(xbee, inDuff,10);
      pause(100);
      int d = atoi(inDuff);
      low(d);
    }
    else if(!strcmp(inBuff,"fdistance"))
    {
      readStr(xbee, inDuff,10);
      pause(100);
      int d = atoi(inDuff);
      d = (d * 25.4);  // Convert to inches
      drive_Fore();
      fdserial_txChar(create,156);
      fdserial_txChar(create,((d)>>8)&0xFF);
      fdserial_txChar(create,((d)&0xFF));
      stop_Bot();
    }
    else if(!strcmp(inBuff,"bdistance"))
    {
      readStr(xbee, inDuff,10);
      pause(100);
      int d = atoi(inDuff);
      d = (d * 25.4);  // Convert to inches
      drive_Back();
      fdserial_txChar(create,156);
      fdserial_txChar(create,((-d)>>8)&0xFF);
      fdserial_txChar(create,((-d)&0xFF));
      stop_Bot();
    }
    else if(!strcmp(inBuff,"ldistance"))
    {
      readStr(xbee, inDuff,10);
      pause(100);
      int d = atoi(inDuff);
      drive_Left();
      fdserial_txChar(create,157);
      fdserial_txChar(create,((d)>>8)&0xFF);
      fdserial_txChar(create,((d)&0xFF));
      stop_Bot();      
    }
    else if(!strcmp(inBuff,"rdistance"))
    {
      readStr(xbee, inDuff,10);
      pause(100);
      int d = atoi(inDuff);
      drive_Rite();
      fdserial_txChar(create,157);
      fdserial_txChar(create,((-d)>>8)&0xFF);
      fdserial_txChar(create,((-d)&0xFF));
      stop_Bot();
    }
    else if(!strcmp(inBuff,"dock")) drive_Dock();
    else if(!strcmp(inBuff,"startmode")) CstartM();
    else
    {
      writeStr(xbee,"??");
      retval = -1;
    }    
  }
  return retval;
}

/* Interpreter language routine. */
void ILcmd()
{
  char inBuff[40];
  char inDuff[5];

  while(1)
  {
    readStr(xbee,inBuff,40);
    if(!strcmp(inBuff, " ")) break;
    if(!strcmp(inBuff, "::")) break;
    if(!strcmp(inBuff,"onPin"))
    {
      writeStr(xbee,"#");
      pause(100);
      readStr(xbee,inDuff,10);
      int d = atoi(inDuff);
      high(d);
      writeStr(xbee,"#");
    }
    if(!strcmp(inBuff,"offPin"))
    {
      writeStr(xbee,"#");
      pause(100);
      readStr(xbee,inDuff,10);
      int d = atoi(inDuff);
      low(d);
      writeStr(xbee,"#");
    }
    if(!strcmp(inBuff,"wait"))
    {
      writeStr(xbee,"#");
      pause(100);
      readStr(xbee,inDuff,10);
      int d = atoi(inDuff);
      pause(d);
      writeStr(xbee,"#");
    }
    if(!strcmp(inBuff,"gofore"))
    {
      drive_Fore();
      writeStr(xbee,"#");
    }
    if(!strcmp(inBuff,"goback"))
    {
      drive_Back();
      writeStr(xbee,"#");
    }
    if(!strcmp(inBuff,"gostop"))
    {
      stop_Bot();
      writeStr(xbee,"#");
    }
    if(!strcmp(inBuff,"fdistance")) // If fdistance
    {
      writeStr(xbee,"#");  // Got it
      pause(100);
      readStr(xbee,inDuff,10); // Get distance value
      int d = atoi(inDuff);  // Convert it
      d = (d * 25.4);  // Convert inches to mm
      drive_Fore();// Start robot forward
      fdserial_txChar(create,156); // Wait distance command
      fdserial_txChar(create,((d)>>8)&0xFF); // High byte
      fdserial_txChar(create,((d)&0xFF));  // Low byte
      stop_Bot();
      // should have travelled the specific distance
      writeStr(xbee,"#");
    }
    if(!strcmp(inBuff,"bdistance")) // If fdistance
    {
      writeStr(xbee,"#");  // Got it
      pause(100);
      readStr(xbee,inDuff,10);
      int d = atoi(inDuff);
      d = (d * 25.4);
      drive_Back();
      fdserial_txChar(create,156);
      fdserial_txChar(create,((-d)>>8)&0xFF);
      fdserial_txChar(create,((-d)&0xFF));
      stop_Bot();
      // should have travelled the specific distance
      writeStr(xbee,"#");
    }
    if(!strcmp(inBuff,"ldistance"))
    {
      writeStr(xbee,"#");
      pause(100);
      readStr(xbee,inDuff,10);
      int d = atoi(inDuff);
      drive_Left();
      fdserial_txChar(create,157); // Wait distance command
      fdserial_txChar(create,((d)>>8)&0xFF); // High byte
      fdserial_txChar(create,((d)&0xFF));  // Low byte
      stop_Bot();
      writeStr(xbee,"#");      
    }
    if(!strcmp(inBuff,"rdistance"))
    {
      writeStr(xbee,"#");
      pause(100);
      readStr(xbee,inDuff,10);
      int d = atoi(inDuff);
      drive_Rite();
      fdserial_txChar(create,157); // Wait distance command
      fdserial_txChar(create,((-d)>>8)&0xFF); // High byte
      fdserial_txChar(create,((-d)&0xFF));  // Low byte
      stop_Bot();
      writeStr(xbee,"#");      
    }
    pause(100);
  }
}

/* Interpreter language routine. */
void DILcmd()
{
  char inBuff[40];
  char inDuff[5];

  while(1)
  {
    readStr(rpi,inBuff,40);
    if(!strcmp(inBuff, " ")) break;
    if(!strcmp(inBuff, "::")) break;
    if(!strcmp(inBuff,"onPin"))
    {
      writeStr(rpi,"#");
      pause(100);
      readStr(rpi,inDuff,10);
      int d = atoi(inDuff);
      high(d);
      writeStr(rpi,"#");
    }
    if(!strcmp(inBuff,"offPin"))
    {
      writeStr(rpi,"#");
      pause(100);
      readStr(rpi,inDuff,10);
      int d = atoi(inDuff);
      low(d);
      writeStr(rpi,"#");
    }
    if(!strcmp(inBuff,"wait"))
    {
      writeStr(rpi,"#");
      pause(100);
      readStr(rpi,inDuff,10);
      int d = atoi(inDuff);
      pause(d);
      writeStr(rpi,"#");
    }
    if(!strcmp(inBuff,"gofore"))
    {
      drive_Fore();
      writeStr(rpi,"#");
    }
    if(!strcmp(inBuff,"goback"))
    {
      drive_Back();
      writeStr(rpi,"#");
    }
    if(!strcmp(inBuff,"gostop"))
    {
      stop_Bot();
      writeStr(rpi,"#");
    }
    if(!strcmp(inBuff,"fdistance")) // If fdistance
    {
      writeStr(rpi,"#");  // Got it
      pause(100);
      readStr(rpi,inDuff,10); // Get distance value
      int d = atoi(inDuff);  // Convert it
      d = (d * 25.4);  // Convert inches to mm
      drive_Fore();// Start robot forward
      fdserial_txChar(create,156); // Wait distance command
      fdserial_txChar(create,((d)>>8)&0xFF); // High byte
      fdserial_txChar(create,((d)&0xFF));  // Low byte
      stop_Bot();
      // should have travelled the specific distance
      writeStr(rpi,"#");
    }
    if(!strcmp(inBuff,"bdistance")) // If fdistance
    {
      writeStr(rpi,"#");  // Got it
      pause(100);
      readStr(rpi,inDuff,10);
      int d = atoi(inDuff);
      d = (d * 25.4);
      drive_Back();
      fdserial_txChar(create,156);
      fdserial_txChar(create,((-d)>>8)&0xFF);
      fdserial_txChar(create,((-d)&0xFF));
      stop_Bot();
      // should have travelled the specific distance
      writeStr(rpi,"#");
    }
    if(!strcmp(inBuff,"ldistance"))
    {
      writeStr(rpi,"#");
      pause(100);
      readStr(rpi,inDuff,10);
      int d = atoi(inDuff);
      drive_Left();
      fdserial_txChar(create,157); // Wait distance command
      fdserial_txChar(create,((d)>>8)&0xFF); // High byte
      fdserial_txChar(create,((d)&0xFF));  // Low byte
      stop_Bot();
      writeStr(rpi,"#");      
    }
    if(!strcmp(inBuff,"rdistance"))
    {
      writeStr(rpi,"#");
      pause(100);
      readStr(rpi,inDuff,10);
      int d = atoi(inDuff);
      drive_Rite();
      fdserial_txChar(create,157); // Wait distance command
      fdserial_txChar(create,((-d)>>8)&0xFF); // High byte
      fdserial_txChar(create,((-d)&0xFF));  // Low byte
      stop_Bot();
      writeStr(rpi,"#");      
    }
    pause(100);
  }
}

void CsafeM(void)
{
  fdserial_txChar(create,128);
  pause(250);
  fdserial_txChar(create,131);
}

void CstartM(void)
{
  fdserial_txChar(create,128);
}

void stop_Bot()
{
  fdserial_txChar(create,145);
  fdserial_txChar(create,0);
  fdserial_txChar(create,0);
  fdserial_txChar(create,0);
  fdserial_txChar(create,0);
}

void drive_Fore()
{
  fdserial_txChar(create,145);
  fdserial_txChar(create,((speed_right)>>8)&0xFF);
  fdserial_txChar(create,((speed_right)&0xFF));
  fdserial_txChar(create,((speed_left)>>8)&0xFF);
  fdserial_txChar(create,((speed_left)&0xFF));
}

void drive_Back()
{
  fdserial_txChar(create,145);
  fdserial_txChar(create,((-speed_right)>>8)&0xFF);
  fdserial_txChar(create,((-speed_right)&0xFF));
  fdserial_txChar(create,((-speed_left)>>8)&0xFF);
  fdserial_txChar(create,((-speed_left)&0xFF));
}

void drive_Left()
{
  fdserial_txChar(create,145);
  fdserial_txChar(create,((turn_right)>>8)&0xFF);
  fdserial_txChar(create,((turn_right)&0xFF));
  fdserial_txChar(create,((-turn_left)>>8)&0xFF);
  fdserial_txChar(create,((-turn_left)&0xFF));
}

void drive_Dock()
{
  fdserial_txChar(create,136);
  pause(250);
  fdserial_txChar(create,1);
}

void drive_Rite()
{
  fdserial_txChar(create,145);
  fdserial_txChar(create,((-turn_right)>>8)&0xFF);
  fdserial_txChar(create,((-turn_right)&0xFF));
  fdserial_txChar(create,((turn_left)>>8)&0xFF);
  fdserial_txChar(create,((turn_left)&0xFF));
}

